﻿Imports System.Net.Sockets
Imports System.Text

Public Class Form1
    Dim numcycles As Integer
    Dim cycleStep As Integer

    Private Sub CmdCon_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdCon.Click
        If SerialPort1.IsOpen = 0 Then
            SerialPort1.PortName = COMPortBox.Text
            SerialPort1.BaudRate = BaudRate.Text
            SerialPort1.Parity = IO.Ports.Parity.None
            SerialPort1.DataBits = 8
            SerialPort1.StopBits = IO.Ports.StopBits.One
            SerialPort1.Open()
            CmdCon.Text = "Close"
        Else
            SerialPort1.Close()
            CmdCon.Text = "Open"
        End If

    End Sub

    Private Sub dcon_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If SerialPort1.IsOpen Then
            SerialPort1.Close()
        End If
    End Sub

    Private Sub snd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles snd.Click
        Dim cmdStr As String
        Dim rcvStr As String
        Dim tempStr As String
        Dim val As Integer
        Dim startMilliseconds As Long
        Dim endMilliseconds As Long
        Dim totalMilliseconds As Long

        cmdStr = sendtxt.Text + Chr(13)

        If (SerialPort1.IsOpen) Then
            startMilliseconds = DateTime.Now.Ticks / TimeSpan.TicksPerMillisecond
            SerialPort1.Write(cmdStr)
            responsetxt.Text = ">>" + cmdStr + responsetxt.Text
            val = InStr(cmdStr, "?")
            If val > 0 Then
                'this is query command
                While (SerialPort1.BytesToRead = 0)
                    'do nothing
                End While
                endMilliseconds = DateTime.Now.Ticks / TimeSpan.TicksPerMillisecond
                totalMilliseconds = endMilliseconds - startMilliseconds
                rcvStr = ""
                tempStr = SerialPort1.ReadExisting()

                While Mid(tempStr, tempStr.Length, 1) <> vbCr
                    rcvStr = rcvStr + tempStr
                    While (SerialPort1.BytesToRead = 0)
                        'do nothing
                    End While
                    tempStr = SerialPort1.ReadExisting()
                End While
                rcvStr = rcvStr + tempStr
                rcvStr = Mid(rcvStr, 1, rcvStr.Length - 2)
                rcvStr = rcvStr + " -->" + Str(totalMilliseconds) + " ms" + vbCr
                responsetxt.Text = "<<" + rcvStr + responsetxt.Text
            End If
        Else
            MsgBox("COM PORT NOT OPEN!")
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each comport As String In My.Computer.Ports.SerialPortNames
            COMPortBox.Items.Add(comport)
        Next

        If COMPortBox.Items.Count > 0 Then
            COMPortBox.SelectedIndex = 0
        End If

    End Sub

    Private Sub ExitProg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitProg.Click
        If SerialPort1.IsOpen Then
            SerialPort1.Close()
        End If
        End
    End Sub
End Class
